<template>
  <q-layout view="hHh LpR fFr" class="shadow-2 rounded-borders">
    <q-header elevated class="shadow-7 ">
      <q-toolbar>
        <q-btn flat dense round @click="leftDrawerOpen = !leftDrawerOpen" aria-label="Menu" >
          <q-icon name="menu" />
        </q-btn>
        <q-toolbar-title >
          Profiterole <span style="font-size:xx-small;">v{{$store.getters.getAppVersion}}</span>
        </q-toolbar-title>
        <q-space />

        <div class="q-gutter-sm row items-center no-wrap">
          <q-btn round flat dense @click="right = !right">
            <q-badge v-show="!store.getters.isLoggedIn" color="gray" class="text-warning" floating>
              <q-icon name="report_problem"></q-icon>
            </q-badge>
            <q-avatar v-show="!store.getters.isLoggedIn" size="23px">
              <q-icon name="account_circle"/>
              <q-tooltip :delay="300" content-class="bg-white text-primary">Not logged</q-tooltip>
            </q-avatar>
            <q-avatar v-show="store.getters.isLoggedIn">
              <q-icon v-show="store.getters.getUserInfos.avatar == ''" name="account_circle" />
              <q-avatar :key="store.getters.getAvatarKey" v-show="store.getters.getUserInfos.avatar != ''" color="default" text-color="white"   >
                  <img :src="store.getters.getUserInfos.avatar">
              </q-avatar>
              <q-tooltip :delay="300" content-class="bg-white text-primary">Account</q-tooltip>
            </q-avatar>
          </q-btn>
          <q-btn flat dense class="text-white" color="primary" @click="$q.fullscreen.toggle()" :icon="$q.fullscreen.isActive ? 'fullscreen_exit' : 'fullscreen'"
           :label="$q.fullscreen.isActive ? '' : ''">
            <q-tooltip :delay="300" content-class="bg-white text-primary">Fullscreen</q-tooltip>
          </q-btn>
        </div>
      </q-toolbar>

      
    </q-header>

    <q-drawer v-model="leftDrawerOpen" bordered content-class="bg-grey-3" side="left" :mini="miniState" @mouseover="miniState = false" @mouseout="miniState = true" 
    :width="200" :breakpoint="400" mini-to-overlay>
      <q-list>
        <q-item clickable tag="a" to="/">
          <q-item-section avatar>
            <q-icon name="home" :class="( (this.$router.currentRoute.path == '/') ? 'text-primary' : 'text-blue-grey-8' )" />
          </q-item-section>
          <q-item-section>
            <q-item-label :class="( (this.$router.currentRoute.path == '/') ? 'text-primary' : 'text-blue-grey-8' )">Hub</q-item-label>
          </q-item-section>
        </q-item>
        <q-item clickable tag="a" to="/modifier">
          <q-item-section avatar>
            <q-icon name="fas fa-table" :class="( (this.$router.currentRoute.path == '/modifier') ? 'text-primary' : 'text-blue-grey-8' )"/>
          </q-item-section>
          <q-item-section>
            <q-item-label :class="( (this.$router.currentRoute.path == '/modifier') ? 'text-primary' : 'text-blue-grey-8' )">LEMA</q-item-label>
          </q-item-section>
        </q-item>
        <q-item v-show="isAdmin()" clickable tag="a" to="/admin">
          <q-item-section avatar>
            <q-icon name="lock" :class="( (this.$router.currentRoute.path == '/admin') ? 'text-primary' : 'text-blue-grey-8' )"/>
          </q-item-section>
          <q-item-section>
            <q-item-label :class="( (this.$router.currentRoute.path == '/admin') ? 'text-primary' : 'text-blue-grey-8' )">Admin</q-item-label>
          </q-item-section>
        </q-item>
        <q-separator spaced/>
        <q-item clickable tag="a" to="/infos">
          <q-item-section avatar>
            <q-icon name="info" :class="( (this.$router.currentRoute.path == '/infos') ? 'text-primary' : 'text-blue-grey-8' )"/>
          </q-item-section>
          <q-item-section>
            <q-item-label :class="( (this.$router.currentRoute.path == '/infos') ? 'text-primary' : 'text-blue-grey-8' )">Infos</q-item-label>
          </q-item-section>
        </q-item>
      </q-list>
      
    </q-drawer>

    <q-drawer v-show="!store.getters.isLoggedIn" v-model="right" side="right" elevated content-class="bg-grey-3" :width="200" :breakpoint="400" show-if-above >
      <div  class="q-pa-md" >
        <q-form @submit="callLogin" @reset="onReset" class="q-gutter-md">
          <q-input filled v-model="username" label="Your username *" hint="Username" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']" />
          <q-input filled :type="isPwd ? 'password' : 'text'" v-model="password" label="Your password *" hint="Password" lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']" >
            <template v-slot:append>
              <q-icon :name="isPwd ? 'visibility_off' : 'visibility'" class="cursor-pointer" @click="isPwd = !isPwd" />
            </template>
          </q-input>
          <div>
            <q-btn label="Sign In" type="submit" color="primary"/>
            <q-btn label="Reset" type="reset" color="primary" flat class="q-ml-sm" />
          </div>
        </q-form>
      </div>
    </q-drawer>

    <q-drawer v-show="store.getters.isLoggedIn" v-model="right" side="right" elevated content-class="bg-grey-3" :mini="rightMiniState" @mouseover="rightMiniState = false" 
    @mouseout="rightMiniState = true" :width="200" :breakpoint="400" mini-to-overlay show-if-above>
      <div  class="q-pa-md">
        <q-list>
          <q-item>
            <q-item-section avatar>
                <q-icon v-show="this.$store.getters.getUserInfos.avatar == ''" name="account_circle" class="text-primary"/>
                <q-avatar :key="this.$store.getters.getAvatarKey" v-show="this.$store.getters.getUserInfos.avatar != ''" color="default" text-color="white"   >
                    <img :src="this.$store.getters.getUserInfos.avatar">
                </q-avatar>
            </q-item-section>
            <q-item-section>
              <q-item-label caption>Logged as</q-item-label>
              <q-item-label>{{this.$store.getters.getUserInfos.firstName}}</q-item-label>
              <q-item-label>{{this.$store.getters.getUserInfos.lastName}}</q-item-label>
            </q-item-section>
          </q-item>
          <q-item clickable tag="a" to="/settings">
            <q-item-section avatar>
              <q-icon name="settings" class="text-blue-grey-8"/>
            </q-item-section>
            <q-item-section>
              <q-item-label>Settings</q-item-label>
            </q-item-section>
          </q-item>
          <q-item clickable tag="a" @click="logout()">
            <q-item-section avatar>
              <q-icon name="input" class="text-negative"/>
            </q-item-section>
            <q-item-section>
              <q-item-label>Logout</q-item-label>
            </q-item-section>
          </q-item>
        </q-list>
      </div>
    </q-drawer>

    <q-page-container>
        <router-view />
    </q-page-container>

    <q-dialog v-model="usersDial" seamless position="bottom">
      <q-card style="width: 350px;">
        <q-linear-progress :value="1" color="primary" />

        <q-card-section class="row items-center no-wrap">
          <div>
            <!-- <div class="text-weight-bold">Logged Users</div> -->
            <div class="text-grey">Logged:<q-chip dense dark color="primary" v-for="name in $store.getters.getLoggedUsers" :key="name">{{name}}</q-chip></div>
          </div>
        </q-card-section>
      </q-card>
    </q-dialog>
  </q-layout>
</template>

<script>
import { openURL } from 'quasar';
import Store from '../store/index';
import api from '../boot/backend-api';
import SockJS from "sockjs-client";
import Stomp from "webstomp-client";


export default {
  name: 'AppLayout',
  data () {
    return {
      leftDrawerOpen: false,
      miniState: true,
      right: false,
      rightMiniState: true,
      loginError: false,
      username: '',
      user: this.$store.getters.getPersonalInfos,
      password: '',
      isPwd: true,
      error: false,
      errors: [],
      store: Store,
      currentRoute: this.$router.currentRoute.path,
      usersDial: true,
      alerts: { 'logerror': { color: 'negative', message: 'You are not allowed to access this page. Please login!', icon: 'report_problem' },
        'welcomeback': { color: 'accent', message: `Welcome back!`, icon: 'face'},
        'wronginfos' : { color: 'negative', message: 'Wrong id or password'},
        'logged': { color: 'positive', message: 'Login successful!'}
      }
    }
  },
  mounted() {
    // include external js
    // this.import("//../boot/sockjs.min.js");
    // this.import("//../boot/stomp.min.js");
    //
    this.store.watch(
      state => state.failedAccess,
      () => {
        if(this.store.getters.getFailedAccess){
          this.showNotif('bottom-right', 'logerror');
          this.store.commit('access_failed', false);
        }
      },
      state => state.isLoggedIn,
      () => {
        if(this.store.getters.isLoggedIn){
          this.rightMiniState = true;
        }else{
          this.rightMiniState = false;
        }
      }
    );
  },
  methods: {
    openURL,
    test(){
      api.ping().then(response => {console.log(response)});
    },
    testFetch(){
      console.log('testfecthc')
      api.testFetch().then(response => { console.log(response)})
    },
    import(pathjs) {
      const plugin = document.createElement("script");
      plugin.setAttribute(
        "src", pathjs
        //"//../boot/sockjs.min.js"
      );
      plugin.async = true;
      document.head.appendChild(plugin);
    },
    tickleConnection() {
      this.connected ? this.disconnect() : this.connect();
    },
    callLogin() {
      this.errors = [];
      this.store.dispatch("login", { user: this.username, password: this.password})
        .then( response => {
          if(response.error){
            console.log('Error', response.error);
            this.showNotif('bottom', 'wronginfos');
            this.password = null;
            this.loginError = true;
            this.errors.push(error);
            this.error = true;
          }else{
            this.store.dispatch('connectSocket').then(() => { this.pingSocket(); });
            this.showNotif('bottom', 'logged');
            this.password = null;
            // this.$router.push("/");
            this.right = false;
          }
        })
    },
    pingSocket() {
      setInterval(function(){ 
        this.store.getters.getStompClient.send("/app/ping", {}, {});
      }, 20000);
    },
    /**
     * DELETE
     */
    testRoles(){
      api.testRoles().then(response => {
        console.log(response.data);
      }).catch(error => {console.log(error)});
    },
    logout() {
      this.store.dispatch("logout", { user: this.store.getters.getUserName})
        .then(() => {
          this.$router.push('/');
        })
    },
    onReset() {
      this.user.username = null;
      this.password = null;
    },
    isAdmin() {
      let names = this.store.getters.getUserInfos.roles.map(role => role.roleName);
      return names.includes('ADMIN_USER');
    },
    showNotif (position, alert) {
      const { color, textColor, multiLine, icon, message, avatar, actions } = this.alerts[alert];
      const buttonColor = color ? 'white' : void 0;
      this.$q.notify({
        color,
        textColor,
        icon: icon,
        message,
        position,
        avatar,
        multiLine,
        actions: actions,
        timeout: 2000
      })
    }
  },
  watch: {
    '$q.appVisible' (state) {
      // if(state) {
      //   // this.showNotif('bottom', 'welcomeback');
      // }
    }
  }
}
</script>

<style>
</style>
